Attribute VB_Name = "VBTools"
Option Explicit

Public Type PictDesc
    cbSizeofStruct As Long
    picType As Long
    hImage As Long
    xExt As Long
    yExt As Long
End Type

Public Type Guid
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(0 To 7) As Byte
End Type

Public Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Public Type BITMAP '14 bytes
        bmType As Long
        bmWidth As Long
        bmHeight As Long
        bmWidthBytes As Long
        bmPlanes As Integer
        bmBitsPixel As Integer
        bmBits As Long
End Type

Public Type BITMAPINFOHEADER
       biSize As Long
       biWidth As Long
       biHeight As Long
       biPlanes As Integer
       biBitCount As Integer
       biCompression As Long
       biSizeImage As Long
       biXPelsPerMeter As Long
       biYPelsPerMeter As Long
       biClrUsed As Long
       biClrImportant As Long
End Type

Public Type RGBQUAD
       rgbBlue As Byte
       rgbGreen As Byte
       rgbRed As Byte
       rgbReserved As Byte
End Type


Public Type BITMAPINFO
       bmiHeader As BITMAPINFOHEADER
       bmiColors As RGBQUAD
End Type

Public Type DIBSECTION
   dsBm As BITMAP
   dsBmih As BITMAPINFOHEADER
   dsBitfields(0 To 2) As Long
   dshSection As Long
   dsOffset As Integer
   dsOffset2 As Integer
End Type

Public Const MAX_PATH = 260
Public Const MAXDWORD = &HFFFF
Public Const FILE_ATTRIBUTE_ARCHIVE = &H20
Public Const FILE_ATTRIBUTE_DIRECTORY = &H10
Public Const FILE_ATTRIBUTE_HIDDEN = &H2
Public Const FILE_ATTRIBUTE_NORMAL = &H80
Public Const FILE_ATTRIBUTE_READONLY = &H1
Public Const FILE_ATTRIBUTE_SYSTEM = &H4
Public Const FILE_ATTRIBUTE_TEMPORARY = &H100
Public Const ERROR_NO_MORE_FILES = 18
Public Const INVALID_HANDLE_VALUE = -1

Public Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

Public Type WIN32_FIND_DATA
    dwFileAttributes As Long
    ftCreationTime As FILETIME
    ftLastAccessTime As FILETIME
    ftLastWriteTime As FILETIME
    nFileSizeHigh As Long
    nFileSizeLow As Long
    dwReserved0 As Long
    dwReserved1 As Long
    cFileName As String * MAX_PATH
    cAlternate As String * 14
End Type

Public Type TFileSearch
   Handle As Long
   Opened As Boolean
   Path As String
   Data As WIN32_FIND_DATA
End Type

Public Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hDC As Long) As Long
Public Declare Function GetObject Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Public Declare Function SelectObject Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long) As Long
Public Declare Function DeleteObject Lib "gdi32.dll" (ByVal hObject As Long) As Long
Public Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Public Declare Function StretchBlt Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
Public Declare Function DeleteDC Lib "gdi32" (ByVal hDC As Long) As Long
Public Declare Function SaveDC Lib "gdi32" (ByVal hDC As Long) As Long
Public Declare Function RestoreDC Lib "gdi32" (ByVal hDC As Long, ByVal nSavedDC As Long) As Long
Public Declare Function SetPixel Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Long
Public Declare Function LineTo Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long) As Long
Public Declare Function MoveToEx Lib "gdi32" (ByVal hDC As Long, ByVal x As Long, ByVal y As Long, ByRef lpPoint As POINTAPI) As Long
Public Declare Function GdiFlush Lib "gdi32" () As Long
Public Declare Function CreateDIBSection Lib "gdi32" (ByVal hDC As Long, ByRef pBitmapInfo As BITMAPINFOHEADER, ByVal un As Long, ppBits As Long, ByVal hdl As Long, ByVal dw As Long) As Long
Public Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long
Public Declare Function CreateFont Lib "gdi32" Alias "CreateFontA" (ByVal nHeight As Long, ByVal nWidth As Long, ByVal nEscapement As Long, ByVal nOrientation As Long, ByVal fnWeight As Long, ByVal fdwItalic As Boolean, ByVal fdwUnderline As Boolean, ByVal fdwStrikeOut As Boolean, ByVal fdwCharSet As Long, ByVal fdwOutputPrecision As Long, ByVal fdwClipPrecision As Long, ByVal fdwQuality As Long, ByVal fdwPitchAndFamily As Long, ByVal lpszFace As String) As Long
Public Declare Function FindFirstFile Lib "kernel32" Alias "FindFirstFileA" (ByVal lpFileName As String, ByRef lpFindFileData As WIN32_FIND_DATA) As Long
Public Declare Function FindNextFile Lib "kernel32" Alias "FindNextFileA" (ByVal hFindFile As Long, ByRef lpFindFileData As WIN32_FIND_DATA) As Long
Public Declare Function GetFileAttributes Lib "kernel32" Alias "GetFileAttributesA" (ByVal lpFileName As String) As Long
Public Declare Function FindClose Lib "kernel32" (ByVal hFindFile As Long) As Long
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (ByRef pDestination As Any, ByRef pSource As Any, ByVal nBytes As Long)
Public Declare Sub ZeroMemory Lib "kernel32" Alias "RtlZeroMemory" (ByVal pDestination As Long, ByVal Length As Long)
Public Declare Function OleCreatePictureIndirect Lib "olepro32.dll" (lpPictDesc As PictDesc, riid As Guid, ByVal fPictureOwnsHandle As Long, IPic As IPicture) As Long
Public Declare Function LoadImage Lib "user32" Alias "LoadImageA" (ByVal hInst As Long, ByVal lpsz As String, ByVal un1 As Long, ByVal n1 As Long, ByVal n2 As Long, ByVal un2 As Long) As Long
Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Public Declare Function GetTickCount Lib "kernel32.dll" () As Long


Public Const LR_CREATEDIBSECTION = &H2000
Public Const LR_DEFAULTCOLOR = &H0
Public Const LR_DEFAULTSIZE = &H40
Public Const LR_LOADFROMFILE = &H10

Public Const PS_SOLID As Long = 0

Public Type POINTAPI
        x As Long
        y As Long
End Type

Public Function AddLog(TxtBox As TextBox, Line As String)
   TxtBox.Text = TxtBox.Text + vbCrLf + Line
   TxtBox.SelStart = Len(TxtBox.Text)
End Function

Public Function BitmapToPicture(ByVal hBmp As Long) As IPicture

    If (hBmp = 0) Then Exit Function
    
    Dim oNewPic As Picture, tPicConv As PictDesc, IGuid As Guid
    
    ' Fill PictDesc structure with necessary parts:
    With tPicConv
    .cbSizeofStruct = Len(tPicConv)
    .picType = vbPicTypeBitmap
    .hImage = hBmp
    End With
    
    ' Fill in IDispatch Interface ID
    With IGuid
    .Data1 = &H20400
    .Data4(0) = &HC0
    .Data4(7) = &H46
    End With
    
    ' Create a picture object:
    OleCreatePictureIndirect tPicConv, IGuid, True, oNewPic
    
    ' Return it:
    Set BitmapToPicture = oNewPic
    
End Function

Public Sub SetOptionButtonByIndex(FrameName As Control, Indx As Integer)
   
   Dim Ctrl As Control
   
    For Each Ctrl In FrameName.Parent.Controls
     If TypeOf Ctrl Is OptionButton Then
       If Ctrl.Container = FrameName Then
                If Ctrl.Tag = Indx Then
                    Ctrl.value = True
                End If
        End If
    End If
    Next
End Sub

Public Sub EnableOrDisableFrameControls(FrameName As Control, EnableChkBox As Boolean)
   Dim Ctrl As Control
   Dim ChkBox As CheckBox
   
    For Each Ctrl In FrameName.Parent.Controls
     If TypeOf Ctrl Is CheckBox Then
        Set ChkBox = Ctrl
        If ChkBox.Container Is FrameName Then
          ChkBox.Enabled = EnableChkBox
        End If
     End If
    Next
End Sub

Public Sub LoadTextBox(ByRef Dest As ListBox, Source As String)
    Dim Startpos As Long
    Dim Endpos As Long
    
    Startpos = 1
    
    Dest.Clear
    Endpos = InStr(Startpos, Source, vbCr)
    While (Endpos <> 0)
        Dest.AddItem Mid(Source, Startpos, Endpos - Startpos)
        Startpos = Endpos + 2 ' skip CR/LF
        Endpos = InStr(Startpos, Source, vbCr)
    Wend
End Sub

Public Sub AssignListToComboBox(ByRef Dest As ComboBox, Source As String, Indx As Long, Optional MaxIndxLimit As Long)
    Dim Startpos As Long
    Dim Endpos As Long
    Dim MaxIndxCount As Long
    
    Startpos = 1
    
    If MaxIndxLimit > 0 Then
       MaxIndxCount = MaxIndxLimit
    Else
       MaxIndxCount = 99999
    End If
    
    Dest.Clear
    Endpos = InStr(Startpos, Source, vbCr)
    While (Endpos <> 0) And (MaxIndxCount > 0)
        Dest.AddItem Mid(Source, Startpos, Endpos - Startpos)
        Startpos = Endpos + 2 ' skip CR/LF
        Endpos = InStr(Startpos, Source, vbCr)
        MaxIndxCount = MaxIndxCount - 1
    Wend
    If Indx < Dest.ListCount Then
       Dest.ListIndex = Indx
    End If
End Sub

Public Sub FileSearch_Close(ByRef FileSearch As TFileSearch)
    If FileSearch.Opened Then
        FindClose (FileSearch.Handle)
        FileSearch.Opened = False
    End If
End Sub

Public Function FileSearch_NextFile(ByVal SearchPath As String, ByVal FileKind As String, ByVal RestartFromFirstFile As Boolean, ByRef FileSearch As TFileSearch) As String
    
    FileSearch_NextFile = ""
    
    If RestartFromFirstFile Or (Not FileSearch.Opened) Then
        
        FileSearch_Close FileSearch ' let's close any previous opened search
        
        If Len(SearchPath) > 0 Then ' let's add a trailing slash if required
            If Right$(SearchPath, 1) = "\" Then
                FileSearch.Path = SearchPath
            Else
                FileSearch.Path = SearchPath + "\"
            End If
        Else
           FileSearch.Path = ".\"
        End If
        
        FileSearch.Handle = FindFirstFile(FileSearch.Path + FileKind, FileSearch.Data)
        If FileSearch.Handle <> INVALID_HANDLE_VALUE Then
           FileSearch_NextFile = FileSearch.Path + FileSearch.Data.cFileName
           FileSearch.Opened = True
        End If
    Else
        If FindNextFile(FileSearch.Handle, FileSearch.Data) <> 0 Then
            FileSearch_NextFile = FileSearch.Path + FileSearch.Data.cFileName
        Else
            FileSearch_Close FileSearch
        End If
    End If
End Function



